// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2022 The Sigstore Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package timestamp

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetTimestampCertChainParams creates a new GetTimestampCertChainParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetTimestampCertChainParams() *GetTimestampCertChainParams {
	return &GetTimestampCertChainParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetTimestampCertChainParamsWithTimeout creates a new GetTimestampCertChainParams object
// with the ability to set a timeout on a request.
func NewGetTimestampCertChainParamsWithTimeout(timeout time.Duration) *GetTimestampCertChainParams {
	return &GetTimestampCertChainParams{
		timeout: timeout,
	}
}

// NewGetTimestampCertChainParamsWithContext creates a new GetTimestampCertChainParams object
// with the ability to set a context for a request.
func NewGetTimestampCertChainParamsWithContext(ctx context.Context) *GetTimestampCertChainParams {
	return &GetTimestampCertChainParams{
		Context: ctx,
	}
}

// NewGetTimestampCertChainParamsWithHTTPClient creates a new GetTimestampCertChainParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetTimestampCertChainParamsWithHTTPClient(client *http.Client) *GetTimestampCertChainParams {
	return &GetTimestampCertChainParams{
		HTTPClient: client,
	}
}

/*
GetTimestampCertChainParams contains all the parameters to send to the API endpoint

	for the get timestamp cert chain operation.

	Typically these are written to a http.Request.
*/
type GetTimestampCertChainParams struct {
	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get timestamp cert chain params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetTimestampCertChainParams) WithDefaults() *GetTimestampCertChainParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get timestamp cert chain params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetTimestampCertChainParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get timestamp cert chain params
func (o *GetTimestampCertChainParams) WithTimeout(timeout time.Duration) *GetTimestampCertChainParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get timestamp cert chain params
func (o *GetTimestampCertChainParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get timestamp cert chain params
func (o *GetTimestampCertChainParams) WithContext(ctx context.Context) *GetTimestampCertChainParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get timestamp cert chain params
func (o *GetTimestampCertChainParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get timestamp cert chain params
func (o *GetTimestampCertChainParams) WithHTTPClient(client *http.Client) *GetTimestampCertChainParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get timestamp cert chain params
func (o *GetTimestampCertChainParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WriteToRequest writes these params to a swagger request
func (o *GetTimestampCertChainParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
